; AVR Term
; T. NAKAGAWA
; 2003/5/31, 6/9

; *_init*_int͊֎~ꂽԂŌĂ΂AȊO͊ꂽԂŌĂ΂
; *_intȊÕ[`̓tOWX^j󂷂BȊÕWX^͑Sĕۑ
; 0x0240-0x025f: stack (32 bytes)

.include "c:\avrtools\appnotes\8515def.inc"


; register
.def	ZERO = r0	; r0 is always 0x00
.def	FF = r1		; r1 is always 0xff


; constant
.equ	DDRA_DFLT = 0x00
.equ	DDRB_DFLT = 0xfd
.equ	PORTB_DFLT = 0x00
.equ	DDRC_DFLT = 0xff
.equ	PORTC_DFLT = 0xf0
.equ	DDRD_DFLT = 0xf0
.equ	PORTD_DFLT = 0x00


; EEPROM
.eseg
.org 0


.equ	XXX = 0x00
.equ	TAB = 0x09
.equ	SPC = 0x20
.equ	BS  = 0x08
.equ	RET = 0x0d
.equ	ESC = 0x1b
.equ	BSL = 0x5c
.equ	APS = 0x27
.equ	SEM = 0x3b
kbd_tbl:
	; normal
	;	  0    1    2    3    4    5    6    7    8    9    a    b    c    d    e    f
	.db	XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, TAB, XXX, XXX
	.db	XXX, XXX, XXX, XXX, XXX, 'q', '1', XXX, XXX, XXX, 'z', 's', 'a', 'w', '2', XXX
	.db	XXX, 'c', 'x', 'd', 'e', '4', '3', XXX, XXX, SPC, 'v', 'f', 't', 'r', '5', XXX
	.db	XXX, 'n', 'b', 'h', 'g', 'y', '6', XXX, XXX, XXX, 'm', 'j', 'u', '7', '8', XXX
	.db	XXX, ',', 'k', 'i', 'o', '0', '9', XXX, XXX, '.', '/', 'l', SEM, 'p', '-', XXX
	.db	XXX, BSL, ':', XXX, '@', '^', XXX, XXX, XXX, XXX, RET, '[', XXX, ']', XXX, XXX
	.db	XXX, XXX, XXX, XXX, XXX, XXX,  BS, XXX, XXX, XXX, BSL, XXX, XXX, XXX, XXX, XXX
	.db	XXX, XXX, XXX, XXX, XXX, XXX, ESC, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX
	; shift key
	.db	XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, TAB, XXX, XXX
	.db	XXX, XXX, XXX, XXX, XXX, 'Q', '!', XXX, XXX, XXX, 'Z', 'S', 'A', 'W', '"', XXX
	.db	XXX, 'C', 'X', 'D', 'E', '$', '#', XXX, XXX, SPC, 'V', 'F', 'T', 'R', '%', XXX
	.db	XXX, 'N', 'B', 'H', 'G', 'Y', '&', XXX, XXX, XXX, 'M', 'J', 'U', APS, '(', XXX
	.db	XXX, '<', 'K', 'I', 'O', XXX, ')', XXX, XXX, '>', '?', 'L', '+', 'P', '=', XXX
	.db	XXX, '_', '*', XXX, '`', '~', XXX, XXX, XXX, XXX, RET, '{', XXX, '}', XXX, XXX
	.db	XXX, XXX, XXX, XXX, XXX, XXX,  BS, XXX, XXX, XXX, '|', XXX, XXX, XXX, XXX, XXX
	.db	XXX, XXX, XXX, XXX, XXX, XXX, ESC, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX, XXX



; CODE
.cseg
.org 0


; Interruption Vector
	rjmp	init	; reset
	rjmp	kbd_int	; EXT_INT0
	rjmp	uart_tx_int	; EXT_INT1
	reti
	reti
	reti
	reti
	rjmp	kbd_rst	; timer/counter0 OVF0
	reti
	rjmp	uart_rx_int	; UART_RXC
	rjmp	uart_tx_int	; UART_DRE
	reti
	reti

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Initialize
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
init:
	cli
	; init register
	clr	ZERO
	clr	FF
	dec	FF
	; init stack
	ldi	ZL, LOW(RAMEND)
	ldi	ZH, HIGH(RAMEND)
	out	SPL, ZL
	out	SPH, ZH
	; init PORT
	ldi	ZL, DDRA_DFLT
	out	DDRA, ZL
	ldi	ZL, DDRB_DFLT
	out	DDRB, ZL
	ldi	ZL, PORTB_DFLT
	out	PORTB, ZL
	ldi	ZL, DDRC_DFLT
	out	DDRC, ZL
	ldi	ZL, PORTC_DFLT
	out	PORTC, ZL
	ldi	ZL, DDRD_DFLT
	out	DDRD, ZL
	ldi	ZL, PORTD_DFLT
	out	PORTD, ZL
	; MCU config
	ldi	ZL, 0x20	; enable sleep
	out	MCUCR, ZL
	ldi	ZL, 80	; inhibit analog comparator
	out	ACSR, ZL
	; init device
	rcall	uart_init
	rcall	lcd_init
	rcall	kbd_init
	sei
	; message
	ldi	ZL, 'A'
	rcall	lcd_putc
	ldi	ZL, 'V'
	rcall	lcd_putc
	ldi	ZL, 'R'
	rcall	lcd_putc
	ldi	ZL, ' '
	rcall	lcd_putc
	ldi	ZL, 'T'
	rcall	lcd_putc
	ldi	ZL, 'e'
	rcall	lcd_putc
	ldi	ZL, 'r'
	rcall	lcd_putc
	ldi	ZL, 'm'
	rcall	lcd_putc
	ldi	ZL, 0x0d
	rcall	lcd_putc
	ldi	ZL, 0x0a
	rcall	lcd_putc
	; run
	rjmp	main


;========================================
; main
main:
	cli
	rcall	kbd_sense
	brcs	m_kbd
	rcall	uart_sense
	brcs	m_uart
	sei
	sleep
	rjmp	main
m_kbd:
	sei
	rcall	kbd_getc
	rcall	uart_putc
	rjmp	main
m_uart:
	sei
	rcall	uart_getc
	rcall	lcd_putc
	rjmp	main

;	rcall	kbd_getc
;	rcall	uart_putc
;	rcall	lcd_putc
;
;	rjmp	main


;========================================
; UART BIOS
;
; uart_init
; uart_sense
; uart_getc
; uart_putc
; uart_rx_int
; uart_tx_int
;
; 0x0060-0x009f: receive buffer
; 0x00a0-0x00df: transmit buffer
;
;========================================

.def	UART_RBUF_PTR = r16	; read pointer of receive buffer
.def	UART_RBUF_SIZE = r17	; size of receive buffer
.def	UART_TBUF_PTR = r18	; read pointer of transmit buffer
.def	UART_TBUF_SIZE = r19	; size of transmit buffer

; constant
.equ	UART_RBUF_BEGIN = 0x0060
.equ	UART_RBUF_MAX = 0x40	; must be 2^n & (<= 0x80)
.equ	UART_TBUF_BEGIN = 0x00a0
.equ	UART_TBUF_MAX = 0x40	; must be 2^n & (<= 0x80)
.equ	UART_PORT_RTS = PORTD
.equ	UART_BIT_RTS = PD5

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; uart_init (interruption is disabled)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uart_init:
	push	ZL
	; configure I/O
	ldi	ZL, (EXP2(RXCIE) | EXP2(RXEN) | EXP2(TXEN))
	out	UCR, ZL
	ldi	ZL, 3	; 115200 baud @ 7.3728MHz clock
	out	UBRR, ZL
	; initialize register
	ldi	UART_RBUF_PTR, 0
	ldi	UART_RBUF_SIZE, 0
	ldi	UART_TBUF_PTR, 0
	ldi	UART_TBUF_SIZE, 0
	; CTS interrupt
	in	ZL, MCUCR
	ori	ZL, EXP2(ISC11)
	andi	ZL, ~EXP2(ISC10)
	out	MCUCR, ZL
	in	ZL, GIMSK	; enable INT1 interruption
	ori	ZL, EXP2(INT1)
	out	GIMSK, ZL
	pop	ZL
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; uart_sense
; out: C (0: Receive Buffer is Empty, 1: Data is Ready)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uart_sense:
	cp	ZERO, UART_RBUF_SIZE
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; uart_getc
; out: ZL (Received Data)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uart_getc:
	; wait until receive buffer is ready
	tst	UART_RBUF_SIZE
	brne	ug0
	sleep
	rjmp	uart_getc
ug0:
	cli
	push	ZH
	ldi	ZL, LOW(UART_RBUF_BEGIN)
	ldi	ZH, HIGH(UART_RBUF_BEGIN)
	add	ZL, UART_RBUF_PTR
	adc	ZH, ZERO
	inc	UART_RBUF_PTR
	andi	UART_RBUF_PTR, (UART_RBUF_MAX - 1)
	dec	UART_RBUF_SIZE
	ld	ZL, Z
	pop	ZH
	; RTS disable
	cpi	UART_RBUF_SIZE, (UART_RBUF_MAX / 2)
	brcc	ug1
	cbi	UART_PORT_RTS, UART_BIT_RTS
ug1:
	sei
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; uart_putc
; in: ZL (Data to transmit)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uart_putc:
	; wait until transmit buffer is ready
	cpi	UART_TBUF_SIZE, UART_TBUF_MAX
	brne	up0
	sleep
	rjmp	uart_putc
up0:
	cli
	push	YL
	push	YH
	mov	YH, UART_TBUF_PTR
	add	YH, UART_TBUF_SIZE
	andi	YH, (UART_TBUF_MAX - 1)
	ldi	YL, LOW(UART_TBUF_BEGIN)
	add	YL, YH
	ldi	YH, HIGH(UART_TBUF_BEGIN)
	adc	YH, ZERO
	st	Y, ZL
	inc	UART_TBUF_SIZE
	pop	YH
	pop	YL
	sei
	sbi	UCR, UDRIE	; enable UART TX interruption
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; uart_rx_int
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uart_rx_int:
	push	ZL
	in	ZL, SREG
	push	ZL
	; receive from UART
	in	ZL, UDR
	; buffer size check
	cpi	UART_RBUF_SIZE, UART_RBUF_MAX
	breq	uri0
	; write to receive buffer
	push	YL
	push	YH
	mov	YH, UART_RBUF_PTR
	add	YH, UART_RBUF_SIZE
	andi	YH, (UART_RBUF_MAX - 1)
	ldi	YL, LOW(UART_RBUF_BEGIN)
	add	YL, YH
	ldi	YH, HIGH(UART_RBUF_BEGIN)
	adc	YH, ZERO
	st	Y, ZL
	inc	UART_RBUF_SIZE
	pop	YH
	pop	YL
	cpi	UART_RBUF_SIZE, (UART_RBUF_MAX * 3 / 4)
	brcs	uri1
uri0:
	; RTS enable
	sbi	UART_PORT_RTS, UART_BIT_RTS
uri1:
	pop	ZL
	out	SREG, ZL
	pop	ZL
	reti

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; uart_tx_int
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
uart_tx_int:
	push	ZL
	in	ZL, SREG
	push	ZL
	; check CTS signal
	sbic	PIND, PIND3	; CTS
	rjmp	uti0	; jump if CTS=H
	; CTS=L
	; check transmit buffer
	tst	UART_TBUF_SIZE
	brne	uti1
uti0:
	; disable UART TX interupption and return
	cbi	UCR, UDRIE	; disable UART interupption (TX)
	rjmp	uti2
uti1:
	; read data from buffer
	push	ZH
	ldi	ZL, LOW(UART_TBUF_BEGIN)
	ldi	ZH, HIGH(UART_TBUF_BEGIN)
	add	ZL, UART_TBUF_PTR
	adc	ZH, ZERO
	inc	UART_TBUF_PTR
	andi	UART_TBUF_PTR, (UART_TBUF_MAX - 1)
	dec	UART_TBUF_SIZE
	ld	ZL, Z
	pop	ZH
	; transmit data to UART
	out	UDR, ZL
	sbi	UCR, UDRIE	; enable UART TX interruption
uti2:
	pop	ZL
	out	SREG, ZL
	pop	ZL
	reti


;========================================
; LCD BIOS
;
; lcd_init
; lcd_putc
;
; 0x00e0-0x021f: screen buffer (LCD_COLUMN * LCD_LINE)
;
;========================================

.def	LCD_REG_CX = r20	; cursor X
.def	LCD_REG_CY = r21	; cursor Y
.def	LCD_REG_STAT = r22	; state
.def	LCD_REG_BUF = r2	; one character buffer
.def	LCD_REG_IO = r23
.def	LCD_REG_IO0 = r24
.def	LCD_REG_IO1 = r5

; constant
.equ	LCD_COLUMN = 40
.equ	LCD_LINE = 8
.equ	LCD_SCRBUF_BGN = 0x00e0
.equ	LCD_PORT_RS = PORTC
.equ	LCD_PORT_CD = PORTC
.equ	LCD_PORT_RD = PORTC
.equ	LCD_PORT_WR = PORTC
.equ	LCD_PORT_DD = DDRA
.equ	LCD_PORT_DR = PINA
.equ	LCD_PORT_DW = PORTA
.equ	LCD_BIT_RS = PC4
.equ	LCD_BIT_CD = PC5
.equ	LCD_BIT_RD = PC7
.equ	LCD_BIT_WR = PC6
.equ	LCD_CMD_CSRPTR = 0x21
.equ	LCD_CMD_TXHOME = 0x40
.equ	LCD_CMD_TXAREA = 0x41
.equ	LCD_CMD_ADPSET = 0x24
.equ	LCD_CMD_AWRON = 0xb0
.equ	LCD_CMD_ARDON = 0xb1
.equ	LCD_CMD_AWROFF = 0xb2
.equ	LCD_CMD_DATAWR = 0xc4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; lcd_init
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
lcd_init:
	push	ZL
	push	ZH
	; initialize register
	ldi	LCD_REG_CX, 0
	ldi	LCD_REG_CY, 0
	ldi	LCD_REG_STAT, 0x00
	; Reset LCD
	cbi	LCD_PORT_RS, LCD_BIT_RS
	ldi	ZL, 20	; wait >= (5 * 1/4.55M) sec
li0:	dec	ZL
	brne	li0
	sbi	LCD_PORT_RS, LCD_BIT_RS
	; Reset Automode
	ldi	LCD_REG_IO0, LCD_CMD_AWROFF
	rcall	lcd_cmd
	; Text Home Address (0x0000)
	ldi	LCD_REG_IO0, 0x00
	mov	LCD_REG_IO1, ZERO
	rcall	lcd_dw2
	ldi	LCD_REG_IO0, LCD_CMD_TXHOME
	rcall	lcd_cmd
	; Text Area Column (40)
	ldi	LCD_REG_IO0, 0x28
	mov	LCD_REG_IO1, ZERO
	rcall	lcd_dw2
	ldi	LCD_REG_IO0, LCD_CMD_TXAREA
	rcall	lcd_cmd
	; Mode (OR, internal CG)
	ldi	LCD_REG_IO0, 0x80
	rcall	lcd_cmd
	; Display Mode (cursor blink, text on, graphic off)
	ldi	LCD_REG_IO0, 0x97
	rcall	lcd_cmd
	; Cursor (1 line)
	ldi	LCD_REG_IO0, 0xa0
	rcall	lcd_cmd
	; Clear Screen
	ldi	LCD_REG_IO0, 0x00
	mov	LCD_REG_IO1, ZERO
	rcall	lcd_dw2
	ldi	LCD_REG_IO0, LCD_CMD_ADPSET
	rcall	lcd_cmd
	ldi	LCD_REG_IO0, LCD_CMD_AWRON
	rcall	lcd_cmd
	ldi	LCD_REG_IO0, 0x00	; space
	ldi	ZL, LOW(LCD_COLUMN * LCD_LINE - 1)
	ldi	ZH, HIGH(LCD_COLUMN * LCD_LINE - 1)
li1:
	rcall	lcd_adw
	subi	ZL, 1
	brcc	li1
	subi	ZH, 1
	brcc	li1
	ldi	LCD_REG_IO0, LCD_CMD_AWROFF
	rcall	lcd_cmd
	; clear screen buffer
	ldi	ZL, LOW(LCD_SCRBUF_BGN)
	ldi	ZH, HIGH(LCD_SCRBUF_BGN)
li2:
	st	Z+, ZERO
	cpi	ZL, LOW(LCD_SCRBUF_BGN + LCD_COLUMN * LCD_LINE)
	brne	li2
	cpi	ZH, HIGH(LCD_SCRBUF_BGN + LCD_COLUMN * LCD_LINE)
	brne	li2
	; initialize cursor
	rcall	lp_movcsr
	pop	ZH
	pop	ZL
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; lcd_putc
; in: ZL (Data to be put)
; 	0x08: Cursor Left
; 	0x09: Tab
; 	0x0a: Cursor Down
; 	0x0d: Carrige Return
; 	0x1bA: Cursor Up
; 	0x1bC: Cursor Right
; 	0x1bH: Cursor Home Position
; 	0x1bI: Back Scroll
; 	0x1bJ: Clear to EOScreen (Cursor doesn't move)
; 	0x1bK: Clear to EOLine (Cursor doesn't move)
; 	0x1bY<y+0x20><x+0x20>: Cursor Move (x, y)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
lcd_putc:
	cpi	LCD_REG_STAT, 0x01
	breq	lp_st1
	cpi	LCD_REG_STAT, 0x02
	breq	lp_st2
	cpi	LCD_REG_STAT, 0x03
	breq	lp_st3
	; state 0
	cpi	ZL, 0x08
	breq	lp_bs
	cpi	ZL, 0x09
	breq	lp_tab
	cpi	ZL, 0x0a
	breq	lp_lf
	cpi	ZL, 0x0d
	breq	lp_cr
	cpi	ZL, 0x1b
	breq	lp_esc
	rjmp	lp_chr
; back space
lp_bs:
	subi	LCD_REG_CX, 1
	brcc	lp_bs0
	inc	LCD_REG_CX
	ret
lp_bs0:
	rcall	lp_movcsr
	ret
; tab
lp_tab:
	mov	ZL, LCD_REG_CX
	andi	ZL, 0x07
	subi	LCD_REG_CX, -(8)
	sub	LCD_REG_CX, ZL
	cpi	LCD_REG_CX, LCD_COLUMN
	brcs	lp_tab0
	ldi	LCD_REG_CX, (LCD_COLUMN - 1)
lp_tab0:
	rcall	lp_movcsr
	ret
; line feed
lp_lf:
	inc	LCD_REG_CY
	cpi	LCD_REG_CY, LCD_LINE
	brcs	lp_lf0
	dec	LCD_REG_CY
	rcall	lp_scrup
	ret
lp_lf0:
	rcall	lp_movcsr
	ret
; carridge return
lp_cr:
	ldi	LCD_REG_CX, 0
	rcall	lp_movcsr
	ret
; escape
lp_esc:
	ldi	LCD_REG_STAT, 0x01
	ret
lp_st1:
	ldi	LCD_REG_STAT, 0x00
	cpi	ZL, 'A'
	breq	lp_up
	cpi	ZL, 'C'
	breq	lp_rt
	cpi	ZL, 'H'
	breq	lp_home
	cpi	ZL, 'I'
	breq	lp_bscr
	cpi	ZL, 'J'
	breq	lp_clreos
	cpi	ZL, 'K'
	breq	lp_clreol
	cpi	ZL, 'Y'
	breq	lp_mv
	rjmp	lp_chr
lp_st2:
	mov	LCD_REG_BUF, ZL
	ldi	LCD_REG_STAT, 0x03
	ret
lp_st3:
	ldi	LCD_REG_STAT, 0x00
	; cursor move
	mov	LCD_REG_CX, ZL
	mov	LCD_REG_CY, LCD_REG_BUF
	subi	LCD_REG_CX, 0x20
	subi	LCD_REG_CY, 0x20
	cpi	LCD_REG_CX, LCD_COLUMN
	brcs	lp_st30
	ldi	LCD_REG_CX, (LCD_COLUMN - 1)
lp_st30:
	cpi	LCD_REG_CY, LCD_LINE
	brcs	lp_st31
	ldi	LCD_REG_CY, (LCD_LINE - 1)
lp_st31:
	rcall	lp_movcsr
	ret
; move
lp_mv:
	ldi	LCD_REG_STAT, 0x02
	ret
; cursor up
lp_up:
	subi	LCD_REG_CY, 1
	brcc	lp_up0
	inc	LCD_REG_CY
	ret
lp_up0:
	rcall	lp_movcsr
	ret
; cursor right
lp_rt:
	inc	LCD_REG_CX
	cpi	LCD_REG_CX, LCD_COLUMN
	brcs	lp_rt0
	dec	LCD_REG_CX
	ret
lp_rt0:
	rcall	lp_movcsr
	ret
; cursor home
lp_home:
	ldi	LCD_REG_CX, 0
	ldi	LCD_REG_CY, 0
	rcall	lp_movcsr
	ret
; back scroll
lp_bscr:
	subi	LCD_REG_CY, 1
	brcc	lp_bscr0
	inc	LCD_REG_CY
	rcall	lp_scrdn
	ret
lp_bscr0:
	rcall	lp_movcsr
	ret
; clear to EOL (End Of Line) (cursor position preserved)
lp_clreol:
	push	YL
	push	YH
	ldi	YL, LCD_COLUMN
	ldi	YH, 0
	sub	YL, LCD_REG_CX
	rcall	lp_putspc
	pop	YH
	pop	YL
	ret
; clear to EOS (End Of Screen) (cursor position preserved)
lp_clreos:
	push	YL
	push	YH
	ldi	YL, LOW(LCD_COLUMN * LCD_LINE)
	ldi	YH, HIGH(LCD_COLUMN * LCD_LINE)
	sub	YL, LCD_REG_CX
	sbc	YH, ZERO
	mov	LCD_REG_BUF, LCD_REG_CY
	lsl	LCD_REG_BUF
	lsl	LCD_REG_BUF
	lsl	LCD_REG_BUF
	sub	YL, LCD_REG_BUF
	sbc	YH, ZERO
	lsl	LCD_REG_BUF
	lsl	LCD_REG_BUF
	sub	YL, LCD_REG_BUF
	sbc	YH, ZERO
	rcall	lp_putspc
	pop	YH
	pop	YL
	ret
; put character
lp_chr:
	; check
	cpi	ZL, 0x20
	brcs	lp_chr3
	cpi	ZL, 0x80
	brcc	lp_chr3
	push	YL
	push	YH
	; calculate RAM Address
	mov	YL, LCD_REG_CX
	mov	YH, LCD_REG_CY
	lsl	YH
	lsl	YH
	lsl	YH
	add	YL, YH
	lsl	YH
	lsl	YH
	add	YL, YH
	ldi	YH, 0
	adc	YH, ZERO
	; adpset
	mov	LCD_REG_IO0, YL
	mov	LCD_REG_IO1, YH
	rcall	lcd_dw2
	ldi	LCD_REG_IO0, LCD_CMD_ADPSET
	rcall	lcd_cmd
	; screen buffer address
	ldi	LCD_REG_IO0, HIGH(LCD_SCRBUF_BGN)
	mov	LCD_REG_IO1, LCD_REG_IO0
	ldi	LCD_REG_IO0, LOW(LCD_SCRBUF_BGN)
	add	YL, LCD_REG_IO0
	adc	YH, LCD_REG_IO1
	; convert
	mov	LCD_REG_IO0, ZL
	subi	LCD_REG_IO0, 0x20	; convert character code
	; write to screen buffer
	st	Y, LCD_REG_IO0
	; put character
	rcall	lcd_dw1
	ldi	LCD_REG_IO0, LCD_CMD_DATAWR
	rcall	lcd_cmd
	; succeed cursor
	inc	LCD_REG_CX
	cpi	LCD_REG_CX, LCD_COLUMN
	brne	lp_chr2
	ldi	LCD_REG_CX, 0
	inc	LCD_REG_CY
	cpi	LCD_REG_CY, LCD_LINE
	brne	lp_chr2
	dec	LCD_REG_CY
	rcall	lp_scrup
lp_chr2:
	rcall	lp_movcsr
	pop	YH
	pop	YL
lp_chr3:
	ret
; move cursor
lp_movcsr:
	mov	LCD_REG_IO0, LCD_REG_CX
	mov	LCD_REG_IO1, LCD_REG_CY
	rcall	lcd_dw2
	ldi	LCD_REG_IO0, LCD_CMD_CSRPTR
	rcall	lcd_cmd
	ret
; put (YH:YL) spaces (YH:YL must be >= 1)
lp_putspc:
	; set position
	mov	LCD_REG_IO0, LCD_REG_CX
	mov	LCD_REG_IO1, LCD_REG_CY
	lsl	LCD_REG_IO1
	lsl	LCD_REG_IO1
	lsl	LCD_REG_IO1
	add	LCD_REG_IO0, LCD_REG_IO1
	lsl	LCD_REG_IO1
	lsl	LCD_REG_IO1
	add	LCD_REG_IO0, LCD_REG_IO1
	mov	LCD_REG_IO1, ZERO
	adc	LCD_REG_IO1, ZERO
	; adpset
	rcall	lcd_dw2
	mov	LCD_REG_BUF, LCD_REG_IO0
	ldi	LCD_REG_IO0, LCD_CMD_ADPSET
	rcall	lcd_cmd
	ldi	LCD_REG_IO0, LCD_CMD_AWRON
	rcall	lcd_cmd
	; screen buffer address
	add	YL, LCD_REG_BUF
	adc	YH, LCD_REG_IO1
	ldi	LCD_REG_IO0, LOW(LCD_SCRBUF_BGN)
	ldi	LCD_REG_IO, HIGH(LCD_SCRBUF_BGN)
	add	YL, LCD_REG_IO0
	adc	YH, LCD_REG_IO
	add	LCD_REG_BUF, LCD_REG_IO0
	adc	LCD_REG_IO1, LCD_REG_IO
	ldi	LCD_REG_IO0, 0x00	; space
lp_putspc0:
	; put spaces
	rcall	lcd_adw
	; write to screen buffer
	st	-Y, LCD_REG_IO0
	cp	YL, LCD_REG_BUF
	brne	lp_putspc0
	cp	YH, LCD_REG_IO1
	brne	lp_putspc0
	ldi	LCD_REG_IO0, LCD_CMD_AWROFF
	rcall	lcd_cmd
	ret
; scroll up
lp_scrup:
	push	YL
	push	YH
	; adpset
	ldi	LCD_REG_IO0, 0x00
	mov	LCD_REG_IO1, ZERO
	rcall	lcd_dw2
	ldi	LCD_REG_IO0, LCD_CMD_ADPSET
	rcall	lcd_cmd
	ldi	LCD_REG_IO0, LCD_CMD_AWRON
	rcall	lcd_cmd
	; Write Screen
 	ldi	YL, LOW(LCD_SCRBUF_BGN + LCD_COLUMN)
	ldi	YH, HIGH(LCD_SCRBUF_BGN + LCD_COLUMN)
lcd_scrup1:
	ld	LCD_REG_IO0, Y+
	rcall	lcd_adw
	cpi	YL, LOW(LCD_SCRBUF_BGN + LCD_COLUMN * LCD_LINE)
	brne	lcd_scrup1
	cpi	YH, HIGH(LCD_SCRBUF_BGN + LCD_COLUMN * LCD_LINE)
	brne	lcd_scrup1
	; spaces
	ldi	LCD_REG_IO0, 0x00
	ldi	YL, LCD_COLUMN
lcd_scrup2:
	rcall	lcd_adw
	dec	YL
	brne	lcd_scrup2
	ldi	LCD_REG_IO0, LCD_CMD_AWROFF
	rcall	lcd_cmd
	; move screen buffer
	ldi	YL, LOW(LCD_SCRBUF_BGN)
	ldi	YH, HIGH(LCD_SCRBUF_BGN)
lcd_scrup3:
	ldd	LCD_REG_IO0, Y+(LCD_COLUMN)
	st	Y+, LCD_REG_IO0
	cpi	YL, LOW(LCD_SCRBUF_BGN + LCD_COLUMN * (LCD_LINE - 1))
	brne	lcd_scrup3
	cpi	YH, HIGH(LCD_SCRBUF_BGN + LCD_COLUMN * (LCD_LINE - 1))
	brne	lcd_scrup3
	; put spaces to screen buffer
	ldi	LCD_REG_IO0, 0x00
lcd_scrup4:
	st	Y+, LCD_REG_IO0
	cpi	YL, LOW(LCD_SCRBUF_BGN + LCD_COLUMN * LCD_LINE)
	brne	lcd_scrup4
	cpi	YH, HIGH(LCD_SCRBUF_BGN + LCD_COLUMN * LCD_LINE)
	brne	lcd_scrup4
	pop	YH
	pop	YL
	ret
; scroll down
lp_scrdn:
	push	YL
	push	YH
	; adpset
	ldi	LCD_REG_IO0, 0
	mov	LCD_REG_IO1, ZERO
	rcall	lcd_dw2
	ldi	LCD_REG_IO0, LCD_CMD_ADPSET
	rcall	lcd_cmd
	ldi	LCD_REG_IO0, LCD_CMD_AWRON
	rcall	lcd_cmd
	; spaces
	ldi	LCD_REG_IO0, 0x00
	ldi	YL, LCD_COLUMN
lcd_scrdn9:
	rcall	lcd_adw
	dec	YL
	brne	lcd_scrdn9
	; Write Screen
 	ldi	YL, LOW(LCD_SCRBUF_BGN)
	ldi	YH, HIGH(LCD_SCRBUF_BGN)
lcd_scrdn0:
	ld	LCD_REG_IO0, Y+
	rcall	lcd_adw
	cpi	YL, LOW(LCD_SCRBUF_BGN + LCD_COLUMN * (LCD_LINE - 1))
	brne	lcd_scrdn0
	cpi	YH, HIGH(LCD_SCRBUF_BGN + LCD_COLUMN * (LCD_LINE - 1))
	brne	lcd_scrdn0
	ldi	LCD_REG_IO0, LCD_CMD_AWROFF
	rcall	lcd_cmd
	; move screen buffer
lcd_scrdn2:
	ld	LCD_REG_IO0, -Y
	std	Y+LCD_COLUMN, LCD_REG_IO0
	cpi	YL, LOW(LCD_SCRBUF_BGN)
	brne	lcd_scrdn2
	cpi	YH, HIGH(LCD_SCRBUF_BGN)
	brne	lcd_scrdn2
	; put spaces to screnn buffer
	ldi	LCD_REG_IO0, 0x00
lcd_scrdn3:
	subi	YL, 1
	sbc	YH, ZERO
	std	Y+LCD_COLUMN, LCD_REG_IO0
	cpi	YL, LOW(LCD_SCRBUF_BGN - LCD_COLUMN)
	brne	lcd_scrdn3
	cpi	YH, HIGH(LCD_SCRBUF_BGN - LCD_COLUMN)
	brne	lcd_scrdn3
	pop	YH
	pop	YL
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; LCD I/O
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CMD
lcd_cmd:
	rcall	lcd_rdy
	mov	LCD_REG_IO, LCD_REG_IO0
	rcall	lcd_io_cw
	ret
; Data Write (1 byte)
lcd_dw1:
	rcall	lcd_rdy
	mov	LCD_REG_IO, LCD_REG_IO0
	rcall	lcd_io_dw
	ret
; Data Write (2 byte)
lcd_dw2:
	rcall	lcd_rdy
	mov	LCD_REG_IO, LCD_REG_IO0
	rcall	lcd_io_dw
	rcall	lcd_rdy
	mov	LCD_REG_IO, LCD_REG_IO1
	rcall	lcd_io_dw
	ret
; Auto Data Read
lcd_adr:
	rcall	lcd_io_sr
	sbrs	LCD_REG_IO, 2
	rjmp	lcd_adr
	rcall	lcd_io_dr
	mov	LCD_REG_IO0, LCD_REG_IO
	ret
; Auto Data Write
lcd_adw:
	rcall	lcd_io_sr
	sbrs	LCD_REG_IO, 3
	rjmp	lcd_adw
	mov	LCD_REG_IO, LCD_REG_IO0
	rcall	lcd_io_dw
	ret
; Wait until LDC is ready for I/O
lcd_rdy:
	rcall	lcd_io_sr
	andi	LCD_REG_IO, 0x03
	cpi	LCD_REG_IO, 0x03
	brne	lcd_rdy
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; LCD Low Level I/O
; ZL: Input/Output
; ZH is not preserved
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Command Write
lcd_io_cw:
	cbi	LCD_PORT_WR, LCD_BIT_WR	; WR active (low)
	out	LCD_PORT_DD, FF	; write mode
	out	LCD_PORT_DW, LCD_REG_IO	; write command
	nop	; wait
	sbi	LCD_PORT_WR, LCD_BIT_WR	; WR inactive (low)
	out	LCD_PORT_DD, ZERO	; read mode
	ret
; Data Write
lcd_io_dw:
	cbi	LCD_PORT_CD, LCD_BIT_CD	; data mode (low)
	cbi	LCD_PORT_WR, LCD_BIT_WR	; WR active (low)
	out	LCD_PORT_DD, FF	; write mode
	out	LCD_PORT_DW, LCD_REG_IO	; write data
	nop	; wait
	sbi	LCD_PORT_WR, LCD_BIT_WR	; WR inactive (low)
	out	LCD_PORT_DD, ZERO	; read mode
	sbi	LCD_PORT_CD, LCD_BIT_CD	; command mode (high)
	ret
; Status Read
lcd_io_sr:
	cbi	LCD_PORT_RD, LCD_BIT_RD	; RD active (low)
	nop	; wait
	in	LCD_REG_IO, LCD_PORT_DR
	sbi	LCD_PORT_RD, LCD_BIT_RD	; RD inactive (low)
	ret
; Data Read
lcd_io_dr:
	cbi	LCD_PORT_CD, LCD_BIT_CD	; data mode (low)
	cbi	LCD_PORT_RD, LCD_BIT_RD	; RD active (low)
	nop	; wait
	in	LCD_REG_IO, LCD_PORT_DR
	sbi	LCD_PORT_RD, LCD_BIT_RD	; RD inactive (low)
	sbi	LCD_PORT_CD, LCD_BIT_CD	; command mode (high)
	ret


;========================================
; Keyboard BIOS
;
; kbd_init
; kbd_sense
; kbd_getc
; kbd_int
; kbd_rst
;
; 0x0220-0x023f: keyboard buffer
;
;========================================

.def	KBD_REG_STAT = r3	; shift(b7), ctrl(b6), alt(b5), multi bytes key stat(b2-b0)
.def	KBD_REG_SREG = r26	; shift register for key scan code
.def	KBD_REG_SREGC = r4	; key scan code parity (b7), shift register counter (b3-b0)
.def	KBD_REG_BUFSIZE = r27
.def	KBD_REG_BUFPTR = r25

; constant
.equ	KBD_BUF_BGN = 0x0220	; ring buffer
.equ	KBD_BUF_MAX = 0x20
.equ	KBD_BIT_SHIFT = 7
.equ	KBD_BIT_CTRL = 6
.equ	KBD_BIT_ALT = 5
.equ	KBD_PORT_DATA = PINB
.equ	KBD_BIT_DATA = PB1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; kbd_init
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
kbd_init:
	push	ZL
	; initialize register
	clr	KBD_REG_STAT
	clr	KBD_REG_SREGC
	ldi	KBD_REG_BUFPTR, 0
	ldi	KBD_REG_BUFSIZE, 0
	; CLK interrupt
	in	ZL, MCUCR
	ori	ZL, EXP2(ISC01)
	andi	ZL, ~EXP2(ISC00)
	out	MCUCR, ZL
	in	ZL, GIMSK	; enable INT0 interruption
	ori	ZL, EXP2(INT0)
	out	GIMSK, ZL
	; initialize timer
	ldi	ZL, 0x05
	out	TCCR0, ZL
	pop	ZL
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; kbd_sense
; out: C (0: keyboard buffer is empty, 1: data is ready)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
kbd_sense:
	cp	ZERO, KBD_REG_BUFSIZE
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; kbd_getc
; out: ZL (data)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
kbd_getc:
	; wait until keyboard buffer is ready
	tst	KBD_REG_BUFSIZE
	brne	kg0
	sleep
	rjmp	kbd_getc
kg0:
	cli
	push	ZH
	ldi	ZL, LOW(KBD_BUF_BGN)
	ldi	ZH, HIGH(KBD_BUF_BGN)
	add	ZL, KBD_REG_BUFPTR
	adc	ZH, ZERO
	inc	KBD_REG_BUFPTR
	andi	KBD_REG_BUFPTR, (KBD_BUF_MAX - 1)
	dec	KBD_REG_BUFSIZE
	ld	ZL, Z
	pop	ZH
	sei
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; kbd_int
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
kbd_int:
	push	ZL
	in	ZL, SREG
	push	ZL
	in	ZL, KBD_PORT_DATA
	bst	ZL, KBD_BIT_DATA
	; reset timer interrupt (1ms)
	ldi	ZL, (256-10)	; 1/(7.373e6/1024)*10 ~= 1ms
	out	TCNT0, ZL
	in	ZL, TIMSK
	ori	ZL, EXP2(TOIE0)
	out	TIMSK, ZL
	out	TIFR, FF
	; process bit
	inc	KBD_REG_SREGC
	mov	ZL, KBD_REG_SREGC
	andi	ZL, 0x0f
	cpi	ZL, 11
	breq	ki_stp	; stop bit
	cpi	ZL, 1
	breq	ki_str	; start bit
	cpi	ZL, 10
	breq	ki_par	; parity bit
	; process data
	lsr	KBD_REG_SREG
	bld	KBD_REG_SREG, 7
	ldi	ZL, 0
	bld	ZL, 7
	eor	KBD_REG_SREGC, ZL
	rjmp	ki_end
ki_str:
	; process start bit (0)
	brtc	ki_end	; OK
	rjmp	ki_rst	; NG
ki_par:
	; process parity bit (odd)
	ldi	ZL, 0
	bld	ZL, 7
	eor	KBD_REG_SREGC, ZL
	bst	KBD_REG_SREGC, 7
	brts	ki_end	; OK
	rjmp	ki_rst	; NG
ki_stp:
	; process stop bit (1)
	brtc	ki_rst	; NG
	rcall	ki_proc
ki_rst:
	; stop timer interrupt
	in	ZL, TIMSK
	andi	ZL, ~EXP2(TOIE0)
	out	TIMSK, ZL
	; reset
	clr	KBD_REG_SREGC
ki_end:
	; end
	pop	ZL
	out	SREG, ZL
	pop	ZL
	reti
; convert key scan code to ascii code & store to keyboard buffer
; assumption: SREG:temporary bit = 1
ki_proc:
	; state
	mov	ZL, KBD_REG_STAT
	andi	ZL, 0x07
	cpi	ZL, 0x01
	breq	kip_s1	; 0xF0
	cpi	ZL, 0x02
	breq	kip_s2	; 0xE0
	cpi	ZL, 0x05
	breq	kip_s5	; 0xE1, 0x??
	cpi	ZL, 0x03
	breq	kip_s3	; 0xE0, 0xF0
	cpi	ZL, 0x04
	breq	kip_s4	; 0xE1
	; special character
	cpi	KBD_REG_SREG, 0x12	; shift key
	breq	kip_shift_on
	cpi	KBD_REG_SREG, 0x14	; control key
	breq	kip_ctrl_on
	cpi	KBD_REG_SREG, 0x11	; alt key
	breq	kip_alt_on
	; multi byte scan code
	cpi	KBD_REG_SREG, 0xe0
	breq	kip_s0s2
	cpi	KBD_REG_SREG, 0xf0
	breq	kip_s0s1
	cpi	KBD_REG_SREG, 0xe1
	breq	kip_s0s4
	;; normal key input
	; check
	cpi	KBD_REG_SREG, 0x80
	brcc	kip_ret
	; shift key
	sbrc	KBD_REG_STAT, KBD_BIT_SHIFT
	subi	KBD_REG_SREG, -(0x80)
	; read EEPROM
;kip0:	sbic	EECR, EEWE	; wait until EEPROM writing finish
;	rjmp	kip0
	out	EEARH, ZERO
	out	EEARL, KBD_REG_SREG
	sbi	EECR, EERE
	in	KBD_REG_SREG, EEDR
	cpi	KBD_REG_SREG, XXX
	breq	kip_ret
	; control key
	sbrs	KBD_REG_STAT, KBD_BIT_CTRL
	rjmp	kip1
	; check (0x40-0x60)
	subi	KBD_REG_SREG, 0x40
	brcs	kip_ret
	cpi	KBD_REG_SREG, 0x20
	brcs	kip1
	subi	KBD_REG_SREG, 0x20
kip1:
	; alt key
	sbrc	KBD_REG_STAT, KBD_BIT_ALT
	subi	KBD_REG_SREG, -(0x80)
kip1a:
	; enqueue to keyboard buffer
	; buffer size check
	cpi	KBD_REG_BUFSIZE, KBD_BUF_MAX
	breq	kip2
	; write to receive buffer
	push	ZH
	mov	ZH, KBD_REG_BUFPTR
	add	ZH, KBD_REG_BUFSIZE
	andi	ZH, (KBD_BUF_MAX - 1)
	ldi	ZL, LOW(KBD_BUF_BGN)
	add	ZL, ZH
	ldi	ZH, HIGH(KBD_BUF_BGN)
	adc	ZH, ZERO
	st	Z, KBD_REG_SREG
	inc	KBD_REG_BUFSIZE
kip2:
	pop	ZH
kip_ret:
	ret
kip_s1:	; 0xF0
	; special character
	dec	KBD_REG_STAT	; s1->s0
	cpi	KBD_REG_SREG, 0x12	; shift key
	breq	kip_shift_off
	cpi	KBD_REG_SREG, 0x14	; control key
	breq	kip_ctrl_off
	cpi	KBD_REG_SREG, 0x11	; alt key
	breq	kip_alt_off
	ret
kip_s2:	; 0xE0
	cpi	KBD_REG_SREG, 0xf0
	brne	kip_s20
	inc	KBD_REG_STAT
	ret
kip_s4:	; 0xE1
	inc	KBD_REG_STAT
	ret
kip_s5:	; 0xE1, 0x??
	dec	KBD_REG_STAT
	dec	KBD_REG_STAT
kip_s3:	; 0xE0, 0xF0
	dec	KBD_REG_STAT
kip_s2s0:
	dec	KBD_REG_STAT
	dec	KBD_REG_STAT
	ret
kip_shift_on:
	bld	KBD_REG_STAT, KBD_BIT_SHIFT
	ret
kip_ctrl_on:
	bld	KBD_REG_STAT, KBD_BIT_CTRL
	ret
kip_alt_on:
	bld	KBD_REG_STAT, KBD_BIT_ALT
	ret
kip_s0s2:
	inc	KBD_REG_STAT
kip_s0s1:
	inc	KBD_REG_STAT
	ret
kip_s0s4:
	inc	KBD_REG_STAT
	inc	KBD_REG_STAT
	inc	KBD_REG_STAT
kip_s2s3:
	inc	KBD_REG_STAT
	ret
kip_shift_off:
	clt
	bld	KBD_REG_STAT, KBD_BIT_SHIFT
	ret
kip_ctrl_off:
	clt
	bld	KBD_REG_STAT, KBD_BIT_CTRL
	ret
kip_alt_off:
	clt
	bld	KBD_REG_STAT, KBD_BIT_ALT
	ret
kip_s20:
	cpi	KBD_REG_SREG, 0x71	; DEL
	brne	kip_s21
	ldi	KBD_REG_SREG, 0x7f
	rjmp	kip1
kip_s21:
	cpi	KBD_REG_SREG, 0x75	; UP
	brne	kip_s22
	ldi	KBD_REG_SREG, 'A'
	rjmp	kip_s26
kip_s22:
	cpi	KBD_REG_SREG, 0x72	; DOWN
	brne	kip_s23
	ldi	KBD_REG_SREG, 'B'
	rjmp	kip_s26
kip_s23:
	cpi	KBD_REG_SREG, 0x6b	; LEFT
	brne	kip_s24
	ldi	KBD_REG_SREG, 'D'
	rjmp	kip_s26
kip_s24:
	cpi	KBD_REG_SREG, 0x74	; RIGHT
	brne	kip_s2s0
	ldi	KBD_REG_SREG, 'C'
	rjmp	kip_s26
kip_s26:
	push	KBD_REG_SREG
	ldi	KBD_REG_SREG, ESC
	rcall	kip1a
	pop	KBD_REG_SREG
	rcall	kip1a

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; kbd_rst
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
kbd_rst:
	push	ZL
	in	ZL, SREG
	push	ZL
	; stop timer interrupt
	in	ZL, TIMSK
	andi	ZL, ~EXP2(TOIE0)
	out	TIMSK, ZL
	; reset
	clr	KBD_REG_SREGC
	; end
	pop	ZL
	out	SREG, ZL
	pop	ZL
	reti
